{  Delphi   Dialogs   .    
  message   ,   . Application.MessageBox,  
     .    , 
      Message.

   unit  Delphi    Help   Dialog Expert.
            
   ,      
  "". 

       (   
  )   : www.chat.ru/~z_ol
           Delphi,
      .

  (c)  .. e-mail: merlin_twi@mail.ru
}
unit FDExpert;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ExptIntf, EditIntf, VirtIntf, ToolIntf,
  Clipbrd;
type
  TFormDialogExpert = class(TForm)
    Label1: TLabel;      ECaption: TEdit;
    Label2: TLabel;      Style: TRadioGroup;
    Image1: TImage;
    EText: TMemo;
    BitBtn1: TBitBtn;    BitBtn2: TBitBtn;
    Buttons: TRadioGroup;
    Extention: TRadioGroup;
    Label3: TLabel;
    IFocus: TRadioGroup;
    IHelp: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    procedure StyleClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  end;
  TDialogExpert = class(TIExpert)
  public
    function GetStyle : TExpertStyle; override;
    function GetIDString : string; override;
    function GetState : TExpertState; override;
    function GetMenuText : string; override;
    function GetName : string; override;
    procedure Execute; override;
  end;

var
  FormDialogExpert: TFormDialogExpert;

  procedure Register;

implementation
{$R *.DFM}
{$R *.RES}

procedure Register;
begin
 RegisterLibraryExpert(TDialogExpert.Create);
end;

function TDialogExpert.GetStyle : TExpertStyle;
 begin result := esStandard; end;
function TDialogExpert.GetIDString : string;
 begin result:='Alex.DialogExpert'; end;
function TDialogExpert.GetState : TExpertState;
 begin result:=[esEnabled]; end;
function TDialogExpert.GetMenuText : string;
 begin result:='Dialog Expert'; end;
function TDialogExpert.GetName : string;
 begin result:='Dialog Expert'; end;
procedure TDialogExpert.Execute;
begin
 if not Assigned(FormDialogExpert) then begin
  FormDialogExpert:=TFormDialogExpert.Create(Application);
  if FormDialogExpert=Nil then
   raise Exception.Create('   ');
 end;
 FormDialogExpert.ShowModal;
end;

procedure TFormDialogExpert.StyleClick(Sender: TObject);
Const
 BitmapNames : array[1..4] of string =
  ('ICONEXCLAMATION','ICONSTOP','ICONINFORMATION','ICONQUESTION');
 CaptionsName : array[0..4] of string =
  ('',' !','','  ',' ');
Var
 i  : integer;
 b  : boolean;
begin
 if Style.ItemIndex>0 then Image1.Picture.Bitmap.LoadFromResourceName(hinstance,
                           BitmapNames[Style.ItemIndex])
 else with Image1.Picture.Bitmap.Canvas do begin
  Brush.Color:=FormDialogExpert.Color;
  FillRect(ClipRect);
 end;
 b:=false;
 for i:=0 to 4 do if ECaption.Text=CaptionsName[i] then b:=true;
 if b then ECaption.Text:=CaptionsName[Style.ItemIndex];
end;

procedure TFormDialogExpert.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Action:=caFree; FormDialogExpert:=Nil;
end;

 // 
procedure TFormDialogExpert.BitBtn1Click(Sender: TObject);
Const Kv = '''';
 StyleNames : array[1..4] of string =
  ('MB_ICONEXCLAMATION','MB_ICONSTOP','MB_ICONINFORMATION','MB_ICONQUESTION');
 ButtonNames : array[0..5] of string =
  ('MB_OK','MB_OKCANCEL','MB_RETRYCANCEL','MB_YESNO','MB_YESNOCANCEL','MB_ABORTRETRYIGNORE');
 FocusNames : array[1..2] of string =
  ('MB_DEFBUTTON2','MB_DEFBUTTON1');
 HelpName = 'MB_HELP';
Var
  S      : string;
  i      : integer;
  EditPos: TEditPos;
  CharPos: TCharPos;
begin
 S:=EText.Text;
 while Pos(#10, S)<>0 do delete(S,Pos(#10, S),1);
 repeat
   i:=Pos(#13, S);
   if i<>0 then S:=copy(S, 1, i-1)+Kv+'#10+'+#10+Kv+copy(S, i+1, length(S));
 until i=0;
 S:='Application.MessageBox('+Kv+S+Kv+','+Kv+ECaption.Text+Kv+', ';
 if Style.ItemIndex>0 then S:=S+StyleNames[Style.ItemIndex]+' or ';
 S:=S+ButtonNames[Buttons.ItemIndex];
 if IFocus.ItemIndex>0 then S:=S+' or '+FocusNames[IFocus.ItemIndex];
 if IHelp.Checked then S:=S+' or '+HelpName;
 S:=S+')';
 case Extention.ItemIndex of
  0: S:='if '+S+'<>ID_YES then exit';
  1: S:='if '+S+'<>ID_OK then exit';
 end;
 S:=S+';';

 with ToolServices.GetModuleInterface(ToolServices.GetCurrentFile).GetEditorInterface.CreateWriter
 do begin
  if UpperCase(ExtractFileExt(ToolServices.GetModuleInterface(ToolServices.GetCurrentFile).GetEditorInterface.FileName))<>'.PAS' then
  begin
   Clipboard.SetTextBuf(pchar(S));
   ShowMessage('     .      .');
  end else
  try
   with ToolServices.GetModuleInterface(ToolServices.GetCurrentFile).GetEditorInterface.GetView(0) do
    begin
      EditPos:=CursorPos;
      ConvertPos(true, EditPos, CharPos);
      i:=CharPosToPos(CharPos);
    end;
   CopyTo(i);
   Insert(pchar(S));
  except
   Clipboard.SetTextBuf(pchar(S));
   ShowMessage('   .     .      .');
  end;
  Free;
 end;
end;

procedure TFormDialogExpert.FormActivate(Sender: TObject);
begin
 with Image1.Picture.Bitmap.Canvas do begin
  Brush.Color:=FormDialogExpert.Color;
  FillRect(ClipRect);
 end;
end;

initialization
 FormDialogExpert:=Nil;
end.

